﻿Imports Urlaubsplaner.dtsPlaner
Public Class frmUrlaubsplan
    Private Sub tsJahrÄndern_Click(sender As Object, e As EventArgs) Handles tsJahrÄndern.Click
        Forms.ShowDataDialog(Of dlgJahrÄndern)()
    End Sub

    Private Sub frmTabbedMonatsweise_Load(sender As Object, e As EventArgs) Handles Me.Load
        'Voreinstellung, damit "JAHR" nicht Nothing oder "" ist
        If My.Settings.TabbedJahr = "" Then My.Settings.TabbedJahr = Date.Now.ToString("yyyy")
        'ListViewHeader
        ListViewHeader("1", lvJanuar)
        ListViewHeader("2", lvFebruar)
        ListViewHeader("3", lvMärz)
        ListViewHeader("4", lvApril)
        ListViewHeader("5", lvMai)
        ListViewHeader("6", lvJuni)
        ListViewHeader("7", lvJuli)
        ListViewHeader("8", lvAugust)
        ListViewHeader("9", lvSeptember)
        ListViewHeader("10", lvOktober)
        ListViewHeader("11", lvNovember)
        ListViewHeader("12", lvDezember)
        'Daten
        ListViewData(lvJanuar)
        ListViewData(lvFebruar)
        ListViewData(lvMärz)
        ListViewData(lvApril)
        ListViewData(lvMai)
        ListViewData(lvJuni)
        ListViewData(lvJuli)
        ListViewData(lvAugust)
        ListViewData(lvSeptember)
        ListViewData(lvOktober)
        ListViewData(lvNovember)
        ListViewData(lvDezember)
    End Sub
    Private Sub ListViewHeader(Monat As String, lvMonat As Windows.Forms.ListView)
        Dim sDate As Date = Date.Parse($"01.{Monat}.{My.Settings.TabbedJahr}")
        Dim eDate As Date = Date.Parse($"{MonatsEnde(Monat).ToShortDateString}")
        With lvMonat
            .View = View.Details
            .GridLines = True
            .Scrollable = True
            .Items.Clear()
            .Columns.Clear()
            .Columns.Add("Mitarbeiter", 100)
            .Columns.Add("Standort", 100)
        End With
        Dim i As Date = sDate
        Do While i < eDate.AddDays(1)
            lvMonat.Columns.Add(i.ToShortDateString, 35)
            i = i.AddDays(1)
        Loop
    End Sub

    Private Sub ListViewData(lvMonat As Windows.Forms.ListView)
        For Each rw In Dts.Mitarbeiter
            If Not rw.Item(Dts.Mitarbeiter.expFullnameColumn).ToString = "<keine Angabe>, <keine Angabe>" Then
                Dim maID = rw.Item(Dts.Mitarbeiter.IDColumn).ToString
                Dim lvItem = lvMonat.Items.Add(rw.Item(Dts.Mitarbeiter.expFullnameColumn).ToString)
                lvItem.SubItems.Add(rw.Item(Dts.Mitarbeiter.StandortColumn).ToString)
                For i As Integer = 2 To lvMonat.Columns.Count - 1
                    Dim filteredRows = Dts.UrlaubKrank.Select($"MitarbeiterID = {CInt(maID)}").Cast(Of UrlaubKrankRow)
                    Dim colDate = Date.Parse(lvMonat.Columns(i).Text.ToString).ToShortDateString
                    Dim dateExists As String = ""
                    For Each rw2 In filteredRows
                        Dim dataDate = rw2.Datum.ToShortDateString
                        If dataDate = colDate Then
                            dateExists = rw2.Art.ToString
                        End If
                    Next
                    lvItem.SubItems.Add(dateExists)
                Next
            End If
        Next
    End Sub

    Private Function MonatsEnde(Monat As String) As Date
        Dim d As Date = Date.Parse($"01.{Monat}.{My.Settings.TabbedJahr}")
        Return d.AddMonths(1).AddDays(-1)
    End Function
End Class