﻿Imports System.ComponentModel
Imports Planer.dtsPlaner
Public Class dlgPlanDetail
    Private Sub dlgPlanDetail_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        If Me.DialogResult <> DialogResult.OK Then Return
        Dim startDatum = Date.Parse(dtbVon.Text).Date
        Dim endDatum = Date.Parse(dtbBis.Text).Date
        If Not startDatum > endDatum Then
            Dim datumDifferenz = (endDatum - startDatum).TotalDays ' - startDatum, endDatum.Tot 'endDatum.Subtract(startDatum).TotalDays
            Dim rwMitarbeiter = bsCmbMitarbeiter.At(Of MitarbeiterRow)
            Dim rwKürzel = bsCmbKuerzel.At(Of KuerzelRow)
            If datumDifferenz > 14 Then
                If msgQuestionWarning($"Der Datumsbereich beträgt {datumDifferenz.ToString} Tage, wirklich weitermachen?") = DialogResult.No Then Return
            End If
            Dim loopDatum = startDatum
            Do While loopDatum < endDatum.AddDays(1)
                Dim ft = GetFeiertag(loopDatum)
                If ft <> Feiertag.KeinFeiertag Then
                    msgInformation($"{ft} | {loopDatum.ToShortDateString}")
                End If
                For Each rwPlan In dts.Plan
                    If rwPlan.Datum = loopDatum Then
                        If rwPlan.MitarbeiterID = rwMitarbeiter.ID Then
                            msgInformation($"Es existiert schon ein Eintrag für den {loopDatum.ToShortDateString}")
                            Return
                        End If
                    End If
                Next
                If cbWochenende.Checked = True Then
                    If loopDatum.DayOfWeek <> DayOfWeek.Saturday And loopDatum.DayOfWeek <> DayOfWeek.Sunday Then
                        dts.Plan.AddPlanRow(loopDatum, rwMitarbeiter, rwKürzel, BemerkungTextBox.Text, "", "")
                    End If
                Else
                    dts.Plan.AddPlanRow(loopDatum, rwMitarbeiter, rwKürzel, BemerkungTextBox.Text, "", "")
                End If
                loopDatum = loopDatum.AddDays(1)
            Loop
            dts.SaveDts(Me)
        Else
            msgInformation("Datum VON muss kleiner BIS sein!")
            dtbVon.SelectAll()
            e.Cancel = True
        End If
    End Sub
#Region "TextBoxBehavior"

    Private Sub TextBox_KeyDown(sender As Object, e As KeyEventArgs) Handles dtbVon.KeyDown, dtbBis.KeyDown
        Dim tb = TryCast(sender, TextBox)
        Select Case e.KeyCode
            Case Keys.Space
                tb.Text = Date.Today.ToShortDateString 'Füllt das aktuelle Datum im ShortDateString-Format in die Textbox
            Case Keys.Enter
                SelectNextControl(tb, True, True, True, True) 'Selektiert das nächste Control via Enter-Taste
            Case Keys.D0 To Keys.D9, Keys.NumPad0 To Keys.NumPad9, Keys.OemPeriod, Keys.Back 'nur Ziffern "." und Backspace zulassen
                'nix tun
            Case Else
                e.SuppressKeyPress = True 'alle anderen Eingaben ablehnen
        End Select
    End Sub

    Private Sub TextBox_Leave(sender As Object, e As EventArgs) Handles dtbVon.Leave, dtbBis.Leave
        Dim dateResult As Date ' As Date - nicht As New Date
        Dim tb = DirectCast(sender, TextBox)  ' DirectCast - nicht TryCast
        If DateTryParseSpecial(tb.Text, dateResult) Then
            tb.Text = dateResult.ToShortDateString
            tb.ForeColor = SystemColors.WindowText
        Else
            tb.Text = "ungültiges Datum"
            tb.ForeColor = Color.Red
        End If
    End Sub

    Private Shared Function DateTryParseSpecial(txt As String, ByRef result As Date) As Boolean
        If Date.TryParse(txt, result) Then Return True
        Dim chars = txt.ToCharArray
        Dim tag = "", monat = Date.Today.Month.ToString, jahr = Date.Today.Year.ToString
        Select Case txt.Length
            Case 1 : tag = {chars(0)}
            Case 2 : tag = {chars(0), chars(1)}
            Case 3 : tag = {chars(0), chars(1)} : monat = {chars(2)}
            Case 4, 6, 8
                tag = {chars(0), chars(1)} : monat = {chars(2), chars(3)}
                If txt.Length > 4 Then jahr = txt.Substring(4)
            Case Else : Return False
        End Select
        Return Date.TryParse($"{tag}.{monat}.{jahr}", result)
    End Function

    Private Sub TextBox_Enter(sender As Object, e As EventArgs) Handles dtbVon.Enter, dtbBis.Enter
        Dim tb = TryCast(sender, TextBox) 'wandelt sender von Object in Textbox um, damit auf alle Propertys zugegriffen werden kann
        tb.SelectAll() 'markiert den gesamten Textboxinhalt - beschleunigt die Eingaben 
    End Sub
#End Region
End Class