﻿Public Class frmTextboxtest
    Private Sub TextBox_KeyDown(sender As Object, e As KeyEventArgs) Handles tb1.KeyDown, tb2.KeyDown
        Dim tb = TryCast(sender, TextBox)
        Select Case e.KeyCode
            Case Keys.Space
                tb.Text = Date.Today.ToShortDateString 'Füllt das aktuelle Datum im ShortDateString-Format in die Textbox
            Case Keys.Enter
                SelectNextControl(tb, True, True, True, True) 'Selektiert das nächste Control via Enter-Taste
            Case Keys.D0 To Keys.D9, Keys.NumPad0 To Keys.NumPad9, Keys.OemPeriod, Keys.Back 'nur Ziffern "." und Backspace zulassen
                'nix tun
            Case Else
                e.SuppressKeyPress = True 'alle anderen Eingaben ablehnen
        End Select
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        msgInformation($"{tb1.Text} | {tb2.Text}")
    End Sub

    Private Sub TextBox_Leave(sender As Object, e As EventArgs) Handles tb1.Leave, tb2.Leave
        Dim dateResult As Date ' As Date - nicht As New Date
        Dim tb = DirectCast(sender, TextBox)  ' DirectCast - nicht TryCast
        If DateTryParseSpecial(tb.Text, dateResult) Then
            tb.Text = dateResult.ToShortDateString
            tb.ForeColor = SystemColors.WindowText
        Else
            tb.Text = "ungültiges Datum"
            tb.ForeColor = Color.Red
        End If
    End Sub

    Private Shared Function DateTryParseSpecial(txt As String, ByRef result As Date) As Boolean
        If Date.TryParse(txt, result) Then Return True
        Dim chars = txt.ToCharArray
        Dim tag = "", monat = Date.Today.Month.ToString, jahr = Date.Today.Year.ToString
        Select Case txt.Length
            Case 1 : tag = {chars(0)}
            Case 2 : tag = {chars(0), chars(1)}
            Case 3 : tag = {chars(0), chars(1)} : monat = {chars(2)}
            Case 4, 6, 8
                tag = {chars(0), chars(1)} : monat = {chars(2), chars(3)}
                If txt.Length > 4 Then jahr = txt.Substring(4)
            Case Else : Return False
        End Select
        Return Date.TryParse($"{tag}.{monat}.{jahr}", result)
    End Function

    Private Sub TextBox_Enter(sender As Object, e As EventArgs) Handles tb1.Enter, tb2.Enter
        Dim tb = TryCast(sender, TextBox) 'wandelt sender von Object in Textbox um, damit auf alle Propertys zugegriffen werden kann
        tb.SelectAll() 'markiert den gesamten Textboxinhalt - beschleunigt die Eingaben 
    End Sub
End Class